package com.sun.xml.internal.ws.binding;

import javax.xml.ws.WebServiceException;
import javax.xml.ws.WebServiceFeature;
import com.sun.istack.internal.Nullable;
import com.sun.istack.internal.NotNull;

public class FeatureListUtil
{
    public FeatureListUtil() {
    }
    
    @NotNull
    public static WebServiceFeatureList mergeList(WebServiceFeatureList... lists) {
        WebServiceFeatureList result = new WebServiceFeatureList();
        for (WebServiceFeatureList list : lists) {
            result.addAll(list);
        }
        return result;
    }
    
    @Nullable
    public static <F extends WebServiceFeature> F mergeFeature(@NotNull Class<F> featureType, @Nullable WebServiceFeatureList list1, @Nullable WebServiceFeatureList list2) throws WebServiceException {
        F feature1 = (list1 != null) ? list1.get(featureType) : null;
        F feature2 = (list2 != null) ? list2.get(featureType) : null;
        if (feature1 == null) {
            return feature2;
        }
        if (feature2 == null) {
            return feature1;
        }
        if (feature1.equals(feature2)) {
            return feature1;
        }
        throw new WebServiceException(feature1 + ", " + feature2);
    }
    
    public static boolean isFeatureEnabled(@NotNull Class<? extends WebServiceFeature> featureType, @Nullable WebServiceFeatureList list1, @Nullable WebServiceFeatureList list2) throws WebServiceException {
        WebServiceFeature mergedFeature = mergeFeature(featureType, list1, list2);
        return mergedFeature != null && mergedFeature.isEnabled();
    }
}
